/* Logarithmic search motion estimation - Initial algorithm */
/* Used for mapping on ARM */

#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>

#define TT 2   /* number of frames */
#define N 144   /* frame dimension */
#define M 176   /* frame dimension */
#define B 16    /* Block size */
void read_sequence(int sequence[TT][N][M])
{
 
/* FILE *infile; */
 int i,j,t;

/* if((infile=fopen("akiyo59.y","rb"))==NULL)
  exit(-1); */

  for(i=0;i<N;i++)
   for(j=0;j<M;j++)
    /*sequence[0][i][j]=(int)fgetc(infile);*/
    sequence[0][i][j]=i+j;

/* fclose(infile); */

/* if((infile=fopen("akiyo60.y","rb"))==NULL)
  exit(-1); */

  for(i=0;i<N;i++)
   for(j=0;j<M;j++)
    /*sequence[1][i][j]=(int)fgetc(infile); */
    sequence[1][i][j]=i-j;

/* fclose(infile);*/
}

void log_motion_estimation(int current[N][M],int previous[N][M],int vectors_x[N/B][M/B],int vectors_y[N/B][M/B])
{
 int x,y,i,j,k,l,p1,p2,dist=0,d,initial=0,min,c,b,bestx,besty,temp_x,temp_y;
 for(c=0;c<N/B;c++)

 for(x=0;x<N/B;x++)  
  for(y=0;y<M/B;y++)
  {
   temp_x=0;
   temp_y=0;
   d=4;
   while(d>0)
    {
     min=255*B*B;
     for(i=-d;i<d+1;i+=d)      
      for(j=-d;j<d+1;j+=d)
      {
       dist=0;
       for(k=0;k<B;k++)  
        for(l=0;l<B;l++)
        {
         p1=current[B*x+k][B*y+l];
          if((B*x+vectors_x[x][y]+i+k)<0 || (B*x+vectors_x[x][y]+i+k)>(N-1) || (B*y+vectors_y[x][y]+j+l)<0 || (B*y+vectors_y[x][y]+j+l)>(M-1))
         	p2=0;
         else
	         p2=previous[B*x+vectors_x[x][y]+i+k][B*y+vectors_y[x][y]+j+l];
         dist+=abs(p1-p2);
        }
        if(dist<min)
        {
         min=dist;
         bestx=i;
         besty=j;
         }
      }
       d=d/2;
       temp_x+=bestx;
       temp_y+=besty;
    }
       vectors_x[x][y]=bestx;
       vectors_y[x][y]=besty;
  }
}


int main()
{
 int input_seq[TT][N][M];
 int motion_vectors_x[N/B][M/B],motion_vectors_y[N/B][M/B];
 read_sequence(input_seq);
 log_motion_estimation(input_seq[1],input_seq[0],motion_vectors_x,motion_vectors_y);
 exit(2);
}
